searchData={"content_type":"text/markdown","items":[{"doc":"Tensorflow lite intepreter for Elixir.\r\nDeep Learning inference framework for embedded devices.","ref":"TflInterp.html","title":"TflInterp","type":"module"},{"doc":"Adjust NMS result to aspect of the input image. (letterbox)","ref":"TflInterp.html#adjust2letterbox/2","title":"TflInterp.adjust2letterbox/2","type":"function"},{"doc":"* nms_result - NMS result {:ok, result}\r\n  * [rx, ry] - aspect ratio of the input image","ref":"TflInterp.html#adjust2letterbox/2-parameters","title":"Parameters: - TflInterp.adjust2letterbox/2","type":"function"},{"doc":"Get name of backend NN framework.","ref":"TflInterp.html#framework/0","title":"TflInterp.framework/0","type":"function"},{"doc":"Ensure that the back-end framework is as expected.","ref":"TflInterp.html#framework?/1","title":"TflInterp.framework?/1","type":"function"},{"doc":"","ref":"TflInterp.html#get_memo/1","title":"TflInterp.get_memo/1","type":"function"},{"doc":"Get the flat binary from the output tensor on the interpreter.","ref":"TflInterp.html#get_output_tensor/3","title":"TflInterp.get_output_tensor/3","type":"function"},{"doc":"* mod   - modules' names or session.\r\n  * index - index of output tensor in the model","ref":"TflInterp.html#get_output_tensor/3-parameters","title":"Parameters - TflInterp.get_output_tensor/3","type":"function"},{"doc":"Get list of the flat binary from the output tensoron the interpreter.","ref":"TflInterp.html#get_output_tensors/2","title":"TflInterp.get_output_tensors/2","type":"function"},{"doc":"* mod   - modules' names or session.\r\n  * range - range of output tensor in the model","ref":"TflInterp.html#get_output_tensors/2-parameters","title":"Parameters - TflInterp.get_output_tensors/2","type":"function"},{"doc":"Get the propaty of the tflite model.","ref":"TflInterp.html#info/1","title":"TflInterp.info/1","type":"function"},{"doc":"* mod - modules' names","ref":"TflInterp.html#info/1-parameters","title":"Parameters - TflInterp.info/1","type":"function"},{"doc":"Invoke prediction.\r\n\r\nTwo modes are toggled depending on the type of input data.\r\nOne is the stateful mode, in which input/output data are stored as model states.\r\nThe other mode is stateless, where input/output data is stored in a session\r\nstructure assigned to the application.","ref":"TflInterp.html#invoke/1","title":"TflInterp.invoke/1","type":"function"},{"doc":"* mod/session - modules name(stateful) or session structure(stateless).","ref":"TflInterp.html#invoke/1-parameters","title":"Parameters - TflInterp.invoke/1","type":"function"},{"doc":"```elixir\r\n    output_bin = session()  # stateless mode\r\n      |> TflInterp.set_input_tensor(0, input_bin)\r\n      |> TflInterp.invoke()\r\n      |> TflInterp.get_output_tensor(0)\r\n  ```","ref":"TflInterp.html#invoke/1-examples","title":"Examples. - TflInterp.invoke/1","type":"function"},{"doc":"Execute post processing: nms.","ref":"TflInterp.html#non_max_suppression_multi_class/5","title":"TflInterp.non_max_suppression_multi_class/5","type":"function"},{"doc":"* mod             - modules' names\r\n  * num_boxes       - number of candidate boxes\r\n  * num_class       - number of category class\r\n  * boxes           - binaries, serialized boxes tensor[`num_boxes`][4]; dtype: float32\r\n  * scores          - binaries, serialized score tensor[`num_boxes`][`num_class`]; dtype: float32\r\n  * opts\r\n    * iou_threshold:   - IOU threshold\r\n    * score_threshold: - score cutoff threshold\r\n    * sigma:           - soft IOU parameter\r\n    * boxrepr:         - type of box representation\r\n       * :center  - center pos and width/height\r\n       * :topleft - top-left pos and width/height\r\n       * :corner  - top-left and bottom-right corner pos","ref":"TflInterp.html#non_max_suppression_multi_class/5-parameters","title":"Parameters - TflInterp.non_max_suppression_multi_class/5","type":"function"},{"doc":"","ref":"TflInterp.html#run/1","title":"TflInterp.run/1","type":"function"},{"doc":"Put a flat binary to the input tensor on the interpreter.","ref":"TflInterp.html#set_input_tensor/4","title":"TflInterp.set_input_tensor/4","type":"function"},{"doc":"* mod   - modules' names or session.\r\n  * index - index of input tensor in the model\r\n  * bin   - input data - flat binary, cf. serialized tensor\r\n  * opts  - data conversion","ref":"TflInterp.html#set_input_tensor/4-parameters","title":"Parameters - TflInterp.set_input_tensor/4","type":"function"},{"doc":"Put flat binaries to the input tensors on the interpreter.","ref":"TflInterp.html#set_input_tensors/3","title":"TflInterp.set_input_tensors/3","type":"function"},{"doc":"* mod   - modules' names or session.\r\n  * from  - first index of input tensor in the model\r\n  * items - list of input data - flat binary, cf. serialized tensor","ref":"TflInterp.html#set_input_tensors/3-parameters","title":"Parameters - TflInterp.set_input_tensors/3","type":"function"},{"doc":"Stop the tflite interpreter.","ref":"TflInterp.html#stop/1","title":"TflInterp.stop/1","type":"function"},{"doc":"* mod - modules' names","ref":"TflInterp.html#stop/1-parameters","title":"Parameters - TflInterp.stop/1","type":"function"},{"doc":"Ensure that the model matches the back-end framework.","ref":"TflInterp.html#validate_model/2","title":"TflInterp.validate_model/2","type":"function"},{"doc":"* model - path of model file\r\n  * url - download site","ref":"TflInterp.html#validate_model/2-parameters","title":"Parameters - TflInterp.validate_model/2","type":"function"},{"doc":"","ref":"TflInterp.PreCompiled.html","title":"TflInterp.PreCompiled","type":"module"},{"doc":"","ref":"TflInterp.PreCompiled.html#download/2","title":"TflInterp.PreCompiled.download/2","type":"function"},{"doc":"","ref":"TflInterp.PreCompiled.html#using_precompiled?/0","title":"TflInterp.PreCompiled.using_precompiled?/0","type":"function"},{"doc":"","ref":"TflInterp.URL.html","title":"TflInterp.URL","type":"module"},{"doc":"Download and process data from url.","ref":"TflInterp.URL.html#download/2","title":"TflInterp.URL.download/2","type":"function"},{"doc":"* url - download site url\r\n  * func - function to process downloaded data","ref":"TflInterp.URL.html#download/2-parameters","title":"Parameters - TflInterp.URL.download/2","type":"function"},{"doc":"Download and save the file from url.","ref":"TflInterp.URL.html#download/3","title":"TflInterp.URL.download/3","type":"function"},{"doc":"* url - download site url\r\n  * path - distination path of downloaded file\r\n  * name - name for the downloaded file","ref":"TflInterp.URL.html#download/3-parameters","title":"Parameters - TflInterp.URL.download/3","type":"function"},{"doc":"","ref":"TflInterp.URL.html#get!/1","title":"TflInterp.URL.get!/1","type":"function"},{"doc":"# TflInterp\r\nTensorflow lite interpreter for Elixir.\r\nDeep Learning inference framework for embedded devices.","ref":"readme.html","title":"TflInterp","type":"extras"},{"doc":"TflInterp is designed based on the following policy.\r\n\r\n1. Provide only the Deep Learning inference. It aims to the poor-resource devices such as IOT and mobile.\r\n2. Easy to understand. The inference part, excluding pre/post-processing, can be written in a few lines.\r\n3. Use trained models from major Deep Learning frameworks that are easy to obtain.\r\n4. Multiple inference models can be used from a single application.\r\n5. There are few dependent modules. It does not have image processing or matrix calculation functions.\r\n6. TflInterp does not block the erlang/elixir process scheduler. It runs as an OS process outside of elixir.\r\n7. The back-end inference engine can be easily replaced. It's easy to keep up with the latest Deep Learninig technology.\r\n\r\nAnd I'm trying to make TflInterp easy to install. \r\n\r\n#","ref":"readme.html#design-policy-features","title":"Design policy (Features) - TflInterp","type":"extras"},{"doc":"The development of Tflinterp started in 2020 Nov. The original idea was to use Nerves to create an AI remote controlled car.\r\nIn the first version, I implemented Yolo3, but the design strongly depended on that model, which made it difficult to use in other applications.\r\nReflecting on that mistake, I redesigned Tflinterp according to the above design guidelines.","ref":"readme.html#short-or-concise-history","title":"short or concise history - TflInterp","type":"extras"},{"doc":"It has been confirmed to work in the following OS environment.\r\n\r\n- Windows Visual C++ 2019\r\n- WSL2/Ubuntu 20.04\r\n- Nerves ARMv6, ARMv7NEON and AArch64","ref":"readme.html#platform","title":"Platform - TflInterp","type":"extras"},{"doc":"- cmake 3.18.6 or later\r\n- git\r\n- Visual C++ 2019 for Windows","ref":"readme.html#requirements","title":"Requirements - TflInterp","type":"extras"},{"doc":"Since 0.1.3, the installation method of this module has changed.\r\nYou may need to remove previously installed TflInterp before installing new version.\r\n\r\nThere are two installation methods. You can choose either one according to your purpose.\r\n\r\nMethod-1. Like any other elixir module, add TflInterp to the dependency list in the mix.exs.\r\n\r\n```\r\ndef deps do\r\n  [\r\n    ...\r\n    {:tfl_interp, \"~> 0.1.14\"},\r\n  ]\r\nend\r\n```\r\n\r\nMethod-2. Download TflInterp to a directory and build it ahead of time.\r\n\r\n```\r\n# download TflInterp in advance.\r\n$ cd /home/{your home}/workdir\r\n$ git clone -b nerves https://github.com/shoz-f/tfl_interp.git\r\n$ cd tfl_interp\r\n$ mix deps.get\r\n$ mix compile\r\n```\r\n\r\nAfter adding the directory path to the dependency list in your mix.exs file, add the following line to the deps() function: `System.put_env(\"NNCOMPILED\", \"YES\")`\r\n\r\nThis line sets an environment variable that instructs your TflInterp application to use the precompiled tfl_interp.exe file, eliminating the need to build it again.\r\n\r\n```\r\ndef deps do\r\n  System.put_env(\"NNCOMPILED\", \"YES)\r\n  [\r\n    ...\r\n    {:tfl_interp, path: \"/home/{your home}/workdir/tfl_interp\"}\r\n  ]\r\nend\r\n```\r\n\r\nThen you run the following commands in your application project.\r\n\r\nFor Desktop application:\r\n\r\n```\r\n$ mix deps.get\r\n$ mix compile\r\n```\r\n\r\nFor Nerves application:\r\n\r\n```\r\n$ export MIX_TARGET=rpi3  # <- specify target device tag\r\n$ mix deps.get\r\n$ mix firmware\r\n```\r\n\r\nIt takes a long time to finish the build. Because it will download the required files - Tensorflow sources,\r\nARM toolchain [^1], etc - at the first build time.\r\nMethod 1 saves the downloaded files under \"{your app}/deps/tfl_interp\". On the other hand,\r\nmethod 2 saves them under \"/home/{your home}/workdir/tfl_interp\".\r\nIf you want to reuse the downloaded files in other applications, I recommend Method 2.\r\n\r\nIn either method 1 or 2, the external modules required for Tensorflow lite are stored under\r\ntheir \"_build/{target}/.cmake_build\" according to the cmakelists.txt that comes with Tensorflow.\r\n\r\n [^1] Unfortunately, the ARM toolchain that comes with Nerves can not build Tensorflow lite. We need to get the toolchain recommended by the Tensorflow project.\r\n\r\nAfter installation, you will have the directory tree like these:\r\n\r\nMethod 1\r\n\r\n```\r\nwork_dir\r\n  +- your-app\r\n       +- _build/\r\n       |    +- dev/\r\n       |         +- .cmake_build/ --- CMakeCash.txt and external modules that Tensorflowlite depends on.\r\n       |         |                    The cmake build outputs are stored here also.\r\n       |         +- lib/\r\n       |         |    +- tfl_interp\r\n       |         |         +- ebin/\r\n       |         |         +- priv\r\n       |         |              +- tfl_interp --- executable: tensorflow interpreter.\r\n       |         :\r\n       |\r\n       +- deps/\r\n       |    + tfl_interp\r\n       |    |   +- 3rd_party/ --- Tensorflow sources, etc.\r\n       |    |   +- lib/ --- TflInterp module.\r\n       |    |   +- src/ --- tfl_interp C++ sources.\r\n       |    |   +- test/\r\n       |    |   +- toolchain/ --- ARM toolchains for Nerves.\r\n       |    |   +- CMakeLists.txt --- CMake configuration for for building tfl_interp.\r\n       |    |   +- mix.exs\r\n       |    :\r\n       |\r\n       +- lib/\r\n       +- test/\r\n       +- mix.exs\r\n```\r\n\r\nMethod 2\r\n\r\n```\r\nwork_dir\r\n  +- your-app\r\n  |    +- _build/\r\n  |    |    +- dev/\r\n  |    |         +- lib/\r\n  |    |         |    +- tfl_interp\r\n  |    |         |         +- ebin/\r\n  |    |         |         +- priv\r\n  |    |         |              +- tfl_interp --- executable: tensorflow interpreter.\r\n  |    |         |                                copy it from the tfl_interp project.\r\n  |    |         :\r\n  |    |\r\n  |    +- deps/\r\n  |    +- lib/\r\n  |    +- test/\r\n  |    +- mix.exs\r\n  |\r\n  +- tfl_interp\r\n       +- 3rd_party/ --- Tensorflow sources, etc.\r\n       +- _build/\r\n       |    +- dev/\r\n       |         +- .cmake_build/ --- CMakeCash.txt and external modules that Tensorflowlite depends on.\r\n       |         |                    The cmake build outputs are stored here also.\r\n       |         +- lib/\r\n       |         |    +- tfl_interp\r\n       |         |         +- ebin/\r\n       |         |         +- priv\r\n       |         |              +- tfl_interp --- executable: tensorflow interpreter.\r\n       |         :\r\n       |\r\n       +- deps/\r\n       +- lib/ --- TflInterp module.\r\n       +- src/ --- tfl_interp C++ sources.\r\n       +- test/\r\n       +- toolchain/ --- ARM toolchains for Nerves.\r\n       +- CMakeLists.txt --- CMake configuration for for building tfl_interp.\r\n       +- mix.exs\r\n```","ref":"readme.html#installation","title":"Installation - TflInterp","type":"extras"},{"doc":"You get the trained tflite model and save it in a directory that your application can read.\r\n\"your-app/priv\" may be good choice.\r\n\r\n```\r\n$ cp your-trained-model.tflite ./priv\r\n```\r\n\r\nNext, you will create a module that interfaces with the deep learning model. The module will need pre-processing and\r\npost-processing in addition to inference processing, as in the example following. TflInterp provides inference processing only.\r\n\r\nYou put `use TflInterp` at the beginning of your module, specify the model path as an optional argument. In the inference\r\nsection, you will put data input to the model (`TflInterp.set_input_tensor/3`), inference execution (`TflInterp.invoke/1`),\r\nand inference result retrieval (`TflInterp.get_output_tensor/2`).\r\n\r\n```elixr:your_model.ex\r\ndefmodule YourApp.YourModel do\r\n  use TflInterp, model: \"priv/your-trained-model.tflite\"\r\n\r\n  def predict(data) do\r\n    # preprocess\r\n    #  to convert the data to be inferred to the input format of the model.\r\n    input_bin = convert-float32-binaries(data)\r\n\r\n    # inference\r\n    #  typical I/O data for Tensorflow lite models is a serialized 32-bit float tensor.\r\n    output_bin =\r\n      __MODULE__\r\n      |> TflInterp.set_input_tensor(0, input_bin)\r\n      |> TflInterp.invoke()\r\n      |> TflInterp.get_output_tensor(0)\r\n\r\n    # postprocess\r\n    #  add your post-processing here.\r\n    #  you may need to reshape output_bin to tensor at first.\r\n    tensor = output_bin\r\n      |> Nx.from_binary({:f, 32})\r\n      |> Nx.reshape({size-x, size-y, :auto})\r\n\r\n    * your-postprocessing *\r\n    ...\r\n  end\r\nend\r\n```\r\n\r\nLet's enjoy ;-)","ref":"readme.html#basic-usage","title":"Basic Usage - TflInterp","type":"extras"},{"doc":"There is MNIST web application in demo_mnist directory. You can do it by following the steps below.\r\n\r\n```shell\r\n$ cd demo_mnist\r\n$ mix deps.get\r\n$ mix run --no-halt\r\n```\r\n\r\nAnd then, please open your browser with \"http://localhost:5000\".","ref":"readme.html#demo","title":"Demo - TflInterp","type":"extras"},{"doc":"TflInterp is licensed under the Apache License Version 2.0.","ref":"readme.html#license","title":"License - TflInterp","type":"extras"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * model downloader can handle the zip compressed file - downloading the zip and extract it.\r\n    * tfl_interp GenServer state has the 'memo' slot to keep private data for any purpose. ex. vocablary dict.","ref":"changelog.html#release-0-1-15-apl-21-2024","title":"Release 0.1.15(Apl 21 2024) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * update Tensorflow lite to version 2.16.1.\r\n    * replace Poison with Jason module.","ref":"changelog.html#release-0-1-14-mar-27-2024","title":"Release 0.1.14(Mar 27 2024) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * (experimental) updated backend loader.","ref":"changelog.html#release-0-1-13-jun-4-2023","title":"Release 0.1.13(Jun 4 2023) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * (experimental) replace environment variable `SKIP_MAKE_TFLINTERP` with \"NNCOMPILED\" to use the precompiled\r\n      tfl_interp.exe. now, the precompiled tfl_interp.exe is downloaded from GitHub at runtime.","ref":"changelog.html#release-0-1-12-may-31-2023","title":"Release 0.1.12(May 31 2023) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * included custom operations: `ExtractImagePatches`.\r\n\r\n  * Bug Fixes and Other Changes\r\n    * add demo applications: Candy, Midas, YoloX and DeepFillV2.\r\n    * revised to shallow clone Tensorflow file set.","ref":"changelog.html#release-0-1-11-apl-29-2023","title":"Release 0.1.11(Apl 29 2023) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * TensorFlow background process has been updated to version 2.12.\r\n    * model downloader now includes a progress bar feature.\r\n    * environment variable `SKIP_MAKE_TFLINTERP` to use the precompiled tfl_interp.exe.\r\n    * included custom operations: `MaxPoolingWithArgmax2D`, `MaxUnpooling2D`, `Convolution2DTransposeBias`.\r\n    * added demo_hairsegmentation.\r\n\r\n  * Bug Fixes and Other Changes\r\n    * the build tool chain in Windows has been replaced from MINGW gcc to Visual C++ 2019.","ref":"changelog.html#release-0-1-10-apl-12-2023","title":"Release 0.1.10(Apl 12 2023) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * feed back from AxonInterp project.\r\n    * added demo_yolov4.\r\n    * revised documents.\r\n    * added the ability to download model files from the url.\r\n    * added the ability to give hints about I/O tensor of the model.","ref":"changelog.html#release-0-1-9-dec-18-2022","title":"Release 0.1.9(Dec 18 2022) - Changelog","type":"extras"},{"doc":"* Breaking Changes (from OnnxInterp 0.1.5)\r\n    * the previous download source of nlohmann-json is gone, so changed to another one.\r\n\r\n  * Bug Fixes and Other Changes (from OnnxInterp 0.1.4)\r\n    * added two more ways to specify box in NMS.","ref":"changelog.html#release-0-1-8-aug-15-2022","title":"Release 0.1.8(Aug 15 2022) - Changelog","type":"extras"},{"doc":"* fixed non_max_suppression_multi_class/7.","ref":"changelog.html#release-0-1-7-jul-11-2022","title":"Release 0.1.7(Jul 11 2022) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * Feedback based on OnnxInterp design.\r\n    * update Tensorflow to 2.9.1.","ref":"changelog.html#release-0-1-6-jun-29-2022","title":"Release 0.1.6(Jun 29 2022) - Changelog","type":"extras"},{"doc":"* Major Features and Improvements\r\n    * add session mode.\r\n    * add processing time measurement function.\r\n    * update Tensorflow to 2.8.0.","ref":"changelog.html#release-0-1-5-apl-4-2022","title":"Release 0.1.5(Apl 4 2022) - Changelog","type":"extras"},{"doc":"* Bug Fixes and Other Changes\r\n    * adjust word alignment of NMS parameter to ARMs.","ref":"changelog.html#release-0-1-4-feb-6-2022","title":"Release 0.1.4(Feb 6 2022) - Changelog","type":"extras"},{"doc":"* Breaking Changes\r\n    * change installation methods. see README.md for detail.\r\n\r\n  * Major Features and Improvements\r\n    * move the directory to download Tensorflow to \"3rd_party\".\r\n    * supported Nerves ARMv6, ARMv7NEON and AArch64(not yet tested).\r\n\r\n  * Bug Fixes and Other Changes\r\n    * corrected CMakeLists scripts for MSYS2/MinGW64. \r\n    * revised demo_mnist to fit cimg_ex 0.1.8.","ref":"changelog.html#release-0-1-3-jan-30-2022","title":"Release 0.1.3(Jan 30 2022) - Changelog","type":"extras"},{"doc":"* Breaking Changes\r\n\r\n  * Major Features and Improvements\r\n    * remove C++ code that depend on C++20 features: src/tfl_interp.cc.\r\n    * limit dependency of mix_cmake to `dev`.\r\n\r\n  * Bug Fixes and Other Changes","ref":"changelog.html#release-0-1-2-jan-17-2022","title":"Release 0.1.2(Jan 17 2022) - Changelog","type":"extras"},{"doc":"# mobile Bert Q&A\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\nSystem.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\n# CAUTION: TflInerp takes several tens of minutes to download the Tensorflow source code.\r\n#         In this setup, we are using TflInterp which is downloaded and built first.\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:nx, \"~> 0.4.1\"}\r\n])\r\n```","ref":"mbert_qa.html","title":"mobile Bert Q&A","type":"extras"},{"doc":"\"BERT Question and Answer\" \r\n\r\n* https://www.tensorflow.org/lite/examples/bert_qa/overview?hl=ja\r\n\r\n\"Google Research/MobileBERT\" \r\n\r\n* https://github.com/google-research/google-research/tree/master/mobilebert\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"mbert_qa.html#0-original-work","title":"0.Original work - mobile Bert Q&A","type":"extras"},{"doc":"","ref":"mbert_qa.html#implementation-for-elixir-using-tflinterp","title":"Implementation for Elixir using TflInterp - mobile Bert Q&A","type":"extras"},{"doc":"```elixir\r\ndefmodule MBertQA.Tokenizer do\r\n  @moduledoc \"\"\"\r\n  Mini Tokenizer for Tensorflow lite's mobileBert example.\r\n  \"\"\"\r\n\r\n  @dic1 :word2token1\r\n  @dic2 :word2token2\r\n  @dic3 :token2word\r\n\r\n  @doc \"\"\"\r\n  Load a vocabulary dictionary.\r\n  \"\"\"\r\n  def load_dic(fname) do\r\n    Enum.each([@dic1, @dic2, @dic3], fn name ->\r\n      if :ets.whereis(name) != :undefined, do: :ets.delete(name)\r\n      :ets.new(name, [:named_table])\r\n    end)\r\n\r\n    File.stream!(fname)\r\n    |> Stream.map(&String.trim_trailing/1)\r\n    |> Stream.with_index()\r\n    |> Enum.each(fn {word, index} ->\r\n      # init dic for encoding.\r\n      case word do\r\n        <<\"##\", trailing::binary>> -> :ets.insert(@dic2, {trailing, index})\r\n        _ -> :ets.insert(@dic1, {word, index})\r\n      end\r\n\r\n      # init dic for decoding.\r\n      :ets.insert(@dic3, {index, word})\r\n    end)\r\n  end\r\n\r\n  @doc \"\"\"\r\n  Tokenize text.\r\n  \"\"\"\r\n  def tokenize(text, tolower \\\\ true) do\r\n    if tolower do\r\n      String.downcase(text)\r\n    else\r\n      text\r\n    end\r\n    |> text2words()\r\n    |> words2tokens()\r\n  end\r\n\r\n  defp text2words(text) do\r\n    text\r\n    # cleansing\r\n    |> String.replace(~r/([[:cntrl:]]|\\xff\\xfd)/, \"\")\r\n    # separate panc with whitespace\r\n    |> String.replace(~r/([[:punct:]])/, \" \\\\1 \")\r\n    # split with whitespace\r\n    |> String.split()\r\n  end\r\n\r\n  defp words2tokens(words) do\r\n    Enum.reduce(words, [], fn word, tokens ->\r\n      case wordpiece1(word, len = String.length(word)) do\r\n        {^len, token} ->\r\n          [token | tokens]\r\n\r\n        {0, token} ->\r\n          [token | tokens]\r\n\r\n        {n, token} ->\r\n          len = len - n\r\n          wordpiece2(String.slice(word, n, len), len, [token | tokens])\r\n      end\r\n    end)\r\n    |> Enum.reverse()\r\n  end\r\n\r\n  defp wordpiece1(_, 0), do: {0, token(\"[UNK]\")}\r\n\r\n  defp wordpiece1(word, n) do\r\n    case lookup_1(String.slice(word, 0, n)) do\r\n      {_piece, token} ->\r\n        {n, token}\r\n\r\n      nil ->\r\n        wordpiece1(word, n - 1)\r\n    end\r\n  end\r\n\r\n  defp wordpiece2(_, 0, tokens), do: [token(\"[UNK]\") | tokens]\r\n\r\n  defp wordpiece2(word, n, tokens) do\r\n    case lookup_2(String.slice(word, 0, n)) do\r\n      {_piece, token} ->\r\n        len = String.length(word) - n\r\n\r\n        if len == 0 do\r\n          [token | tokens]\r\n        else\r\n          wordpiece2(String.slice(word, n, len), len, [token | tokens])\r\n        end\r\n\r\n      nil ->\r\n        wordpiece2(word, n - 1, tokens)\r\n    end\r\n  end\r\n\r\n  defp lookup_1(x), do: lookup(@dic1, x)\r\n  defp lookup_2(x), do: lookup(@dic2, x)\r\n  defp lookup(dic, x), do: List.first(:ets.lookup(dic, x))\r\n\r\n  @doc \"\"\"\r\n  Get token of `word`.\r\n  \"\"\"\r\n  def token(word) do\r\n    try do\r\n      :ets.lookup_element(@dic1, word, 2)\r\n    rescue\r\n      ArgumentError -> nil\r\n    end\r\n  end\r\n\r\n  @doc \"\"\"\r\n  Decode the token list `tokens`.\r\n  \"\"\"\r\n  def decode(tokens) do\r\n    Enum.map(tokens, fn x -> :ets.lookup_element(@dic3, x, 2) end)\r\n  end\r\nend\r\n```\r\n\r\n```elixir\r\ndefmodule MBertQA.Feature do\r\n  @moduledoc \"\"\"\r\n  Feature converter for Tensorflow lite's mobileBert example.\r\n\r\n  Feature tensor[4][] is consisted of\r\n    [0] list of tokens converted from query and contex text in the dictionary.\r\n    [1] list of token masks. all are 1.\r\n    [2] segment type indicator. 0 for query, 1 for context.\r\n    [3] index of the token's position in the context map. see bellow.\r\n\r\n  Context map is a list of words separated from the context by whitespace.\r\n  \"\"\"\r\n\r\n  alias MBertQA.Tokenizer\r\n\r\n  @max_seq 384\r\n  @max_query 64\r\n\r\n  defdelegate load_dic(fname), to: Tokenizer, as: :load_dic\r\n\r\n  @doc \"\"\"\r\n  \"\"\"\r\n  def convert(query, context) do\r\n    {t_query, room} = convert_query(query)\r\n    {t_context, room, context_map} = convert_context(context, room)\r\n\r\n    {\r\n      Nx.concatenate([cls(), t_query, sep(0), t_context, sep(1), padding(room)], axis: 1),\r\n      context_map\r\n    }\r\n  end\r\n\r\n  defp convert_query(text, room \\\\ @max_seq - 3) do\r\n    t_query = convert_text(text, @max_query, 0)\r\n\r\n    {\r\n      t_query,\r\n      room - Nx.axis_size(t_query, 1)\r\n    }\r\n  end\r\n\r\n  defp convert_context(text, room) do\r\n    context_map = String.split(text)\r\n\r\n    {t_context, room} =\r\n      context_map\r\n      |> Stream.with_index()\r\n      |> Enum.reduce_while({[], room}, fn\r\n        {_, _}, {_, 0} = res ->\r\n          {:halt, res}\r\n\r\n        {word, index}, {t_context, max_len} ->\r\n          t_word = convert_text(word, max_len, 1, index)\r\n          {:cont, {[t_word | t_context], max_len - Nx.axis_size(t_word, 1)}}\r\n      end)\r\n\r\n    {\r\n      Enum.reverse(t_context) |> Nx.concatenate(axis: 1),\r\n      room,\r\n      context_map\r\n    }\r\n  end\r\n\r\n  defp convert_text(text, max_len, segment, index \\\\ -1) do\r\n    tokens =\r\n      text\r\n      |> Tokenizer.tokenize()\r\n      |> Enum.take(max_len)\r\n      |> Nx.tensor()\r\n\r\n    len = Nx.axis_size(tokens, 0)\r\n\r\n    Nx.stack([\r\n      tokens,\r\n      Nx.broadcast(1, {len}),\r\n      Nx.broadcast(segment, {len}),\r\n      Nx.broadcast(index, {len})\r\n    ])\r\n    |> Nx.as_type({:s, 32})\r\n  end\r\n\r\n  defp cls() do\r\n    Nx.tensor([[Tokenizer.token(\"[CLS]\")], [1], [0], [-1]], type: {:s, 32})\r\n  end\r\n\r\n  defp sep(segment) do\r\n    Nx.tensor([[Tokenizer.token(\"[SEP]\")], [1], [segment], [-1]], type: {:s, 32})\r\n  end\r\n\r\n  defp padding(n) do\r\n    Nx.tensor([0, 0, 0, -1], type: {:s, 32})\r\n    |> Nx.broadcast({4, n}, axes: [0])\r\n  end\r\nend\r\n```","ref":"mbert_qa.html#1-defining-companion-modules","title":"1.Defining companion modules - mobile Bert Q&A","type":"extras"},{"doc":"* Pre-processing: \r\n\r\n* Post-processing: \r\n\r\n```elixir\r\ndefmodule MBertQA do\r\n  @moduledoc \"\"\"\r\n  Documentation for `MBertQA`.\r\n  \"\"\"\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/lite-model_mobilebert_1_metadata_1.tflite\",\r\n    url:\r\n      \"https://github.com/shoz-f/tfl_interp/releases/download/0.0.1/lite-model_mobilebert_1_metadata_1.tflite\"\r\n\r\n  alias MBertQA.Feature\r\n\r\n  @max_ans 32\r\n  @predict_num 5\r\n\r\n  def setup() do\r\n    Feature.load_dic(\"./model/vocab.txt\")\r\n  end\r\n\r\n  def apply(query, context, predict_num \\\\ @predict_num) do\r\n    # pre-processing\r\n    {feature, context_map} = Feature.convert(query, context)\r\n\r\n    # prediction\r\n    mod =\r\n      __MODULE__\r\n      |> NNInterp.set_input_tensor(0, Nx.to_binary(feature[0]))\r\n      |> NNInterp.set_input_tensor(1, Nx.to_binary(feature[1]))\r\n      |> NNInterp.set_input_tensor(2, Nx.to_binary(feature[2]))\r\n      |> NNInterp.invoke()\r\n\r\n    [end_logits, beg_logits] =\r\n      Enum.map(0..1, fn x ->\r\n        NNInterp.get_output_tensor(mod, x)\r\n        |> Nx.from_binary({:f, 32})\r\n      end)\r\n\r\n    # post-processing\r\n    [beg_index, end_index] =\r\n      Enum.map([beg_logits, end_logits], fn t ->\r\n        Nx.argsort(t, direction: :desc)\r\n        |> Nx.slice_along_axis(0, predict_num)\r\n        |> Nx.to_flat_list()\r\n        |> Enum.filter(&(feature[3][&1] >= 0))\r\n      end)\r\n\r\n    for b <- beg_index, e <- end_index, b <= e, e - b + 1 < @max_ans do\r\n      {b, e, Nx.to_number(Nx.add(beg_logits[b], end_logits[e]))}\r\n    end\r\n    |> Enum.sort(&(elem(&1, 2) >= elem(&2, 2)))\r\n    |> Enum.take(predict_num)\r\n    # make answer text with score\r\n    |> Enum.map(fn {b, e, score} ->\r\n      b = Nx.to_number(feature[3][b])\r\n      e = Nx.to_number(feature[3][e])\r\n\r\n      {\r\n        Enum.slice(context_map, b..e) |> Enum.join(\" \"),\r\n        score\r\n      }\r\n    end)\r\n  end\r\nend\r\n```\r\n\r\nLaunch `MBertQA`.\r\n\r\n```elixir\r\n# TflInterp.stop(MBertQA)\r\nMBertQA.start_link([])\r\n```\r\n\r\nDisplays the properties of the `MBertQA` model.\r\n\r\n```elixir\r\nTflInterp.info(MBertQA)\r\n```","ref":"mbert_qa.html#2-defining-the-inference-module-mbertqa","title":"2.Defining the inference module: MBertQA - mobile Bert Q&A","type":"extras"},{"doc":"```elixir\r\nMBertQA.setup()\r\n```\r\n\r\n```elixir\r\ncontext = \"\"\"\r\nGoogle LLC is an American multinational technology company that specializes in\r\nInternet-related services and products, which include online advertising\r\ntechnologies, search engine, cloud computing, software, and hardware. It is\r\nconsidered one of the Big Four technology companies, alongside Amazon, Apple,\r\nand Facebook.\r\n\r\nGoogle was founded in September 1998 by Larry Page and Sergey Brin while they\r\nwere Ph.D. students at Stanford University in California. Together they own\r\nabout 14 percent of its shares and control 56 percent of the stockholder voting\r\npower through supervoting stock. They incorporated Google as a California\r\nprivately held company on September 4, 1998, in California. Google was then\r\nreincorporated in Delaware on October 22, 2002. An initial public offering (IPO)\r\ntook place on August 19, 2004, and Google moved to its headquarters in Mountain\r\nView, California, nicknamed the Googleplex. In August 2015, Google announced\r\nplans to reorganize its various interests as a conglomerate called Alphabet Inc.\r\nGoogle is Alphabet's leading subsidiary and will continue to be the umbrella\r\ncompany for Alphabet's Internet interests. Sundar Pichai was appointed CEO of\r\nGoogle, replacing Larry Page who became the CEO of Alphabet.\r\n\"\"\"\r\n```\r\n\r\n```elixir\r\n\"What is CEO of Google?\"\r\n|> MBertQA.apply(context, 3)\r\n|> Enum.each(fn {ans, score} ->\r\n  IO.puts(\"\\n>ANS: \\\"#{ans}\\\", score:#{score}\")\r\nend)\r\n```","ref":"mbert_qa.html#3-let-s-try-it","title":"3.Let's try it - mobile Bert Q&A","type":"extras"},{"doc":"&#9633;","ref":"mbert_qa.html#4-til","title":"4.TIL ;-) - mobile Bert Q&A","type":"extras"},{"doc":"# Pose Estimation: MoveNet\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\nSystem.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:nx, \"~> 0.4.0\"},\r\n  {:cimg, \"~> 0.1.15\"},\r\n  {:exprintf, \"~> 0.2.1\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"movenet.html","title":"Pose Estimation: MoveNet","type":"extras"},{"doc":"* MoveNet: Ultra fast and accurate pose detection model \r\n  https://www.tensorflow.org/hub/tutorials/movenet\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"movenet.html#0-original-work","title":"0.Original work - Pose Estimation: MoveNet","type":"extras"},{"doc":"","ref":"movenet.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Pose Estimation: MoveNet","type":"extras"},{"doc":"* Model\r\n\r\n  lite-model_movenet_singlepose_lightning_tflite_int8_4.tflite\r\n\r\n* Pre-processing\r\n\r\n  Resize the input image to the size {192,192}, 32bit integer to {0,255} and keep aspect ratio.\r\n\r\n* Post-processing\r\n\r\n  output[0] - 17 keypoints (in the order of: [nose, left eye, right eye, left ear, right ear, left shoulder, right shoulder, left elbow, right elbow, left wrist, right wrist, left hip, right hip, left knee, right knee, left ankle, right ankle]). Make pairs of keypoints as \"bone\"\r\n\r\n```elixir\r\ndefmodule Movenet do\r\n  @width 192\r\n  @height 192\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/lite-model_movenet_singlepose_lightning_tflite_int8_4.tflite\",\r\n    url:\r\n      \"https://tfhub.dev/google/lite-model/movenet/singlepose/lightning/tflite/int8/4?lite-format=tflite\",\r\n    inputs: [u8: {1, @height, @width, 3}],\r\n    outputs: [f32: {1, 1, 17, 3}]\r\n\r\n  @prepro CImg.builder()\r\n          |> CImg.resize({@width, @height}, :ul, 0)\r\n          |> CImg.to_binary(dtype: \"  NNInterp.set_input_tensor(0, input0)\r\n      |> NNInterp.invoke()\r\n      |> NNInterp.get_output_tensor(0)\r\n      |> Nx.from_binary(:f32)\r\n      |> Nx.reshape({17, 3})\r\n\r\n    # postprocess\r\n    {inv_w, inv_h} = inv_aspect(img)\r\n    joints = Nx.multiply(output0, Nx.tensor([inv_h, inv_w, 1.0]))\r\n\r\n    {:ok, to_bones(joints)}\r\n  end\r\n\r\n  @bones [\r\n    {0, 1, :fuchsia},\r\n    {0, 2, :aqua},\r\n    {1, 3, :fuchsia},\r\n    {2, 4, :aqua},\r\n    {0, 5, :fuchsia},\r\n    {0, 6, :aqua},\r\n    {5, 7, :fuchsia},\r\n    {7, 9, :fuchsia},\r\n    {6, 8, :aqua},\r\n    {8, 10, :aqua},\r\n    {5, 6, :yellow},\r\n    {5, 11, :fuchsia},\r\n    {6, 12, :aqua},\r\n    {11, 12, :yellow},\r\n    {11, 13, :fuchsia},\r\n    {13, 15, :fuchsia},\r\n    {12, 14, :aqua},\r\n    {14, 16, :aqua}\r\n  ]\r\n\r\n  def to_bones(t, threshold \\\\ 0.11) do\r\n    Enum.flat_map(@bones, fn {p1, p2, color} ->\r\n      [y1, x1, score1] = Nx.to_flat_list(t[p1])\r\n      [y2, x2, score2] = Nx.to_flat_list(t[p2])\r\n\r\n      if score1 > threshold && score2 > threshold do\r\n        [{x1, y1, x2, y2, color}]\r\n      else\r\n        []\r\n      end\r\n    end)\r\n  end\r\n\r\n  defp inv_aspect(img) do\r\n    {w, h, _, _} = CImg.shape(img)\r\n    if w > h, do: {1.0, w / h}, else: {h / w, 1.0}\r\n  end\r\nend\r\n```\r\n\r\nLaunch `Movenet`.\r\n\r\n```elixir\r\n# TflInterp.stop(Movenet)\r\nMovenet.start_link([])\r\n```\r\n\r\nDisplay the properties of the `Movenet` model.\r\n\r\n```elixir\r\nTflInterp.info(Movenet)\r\n```","ref":"movenet.html#1-defining-the-inference-module-movenet","title":"1.Defining the inference module: MoveNet - Pose Estimation: MoveNet","type":"extras"},{"doc":"```elixir\r\ndefmodule LiveMovenet do\r\n  def img_list(src, range) do\r\n    Enum.map(range, fn i ->\r\n      name = ExPrintf.sprintf(\"%03d.jpg\", [i])\r\n      path = Path.join(src, name)\r\n      CImg.load(path)\r\n    end)\r\n  end\r\n\r\n  def animate(img_list) do\r\n    Kino.animate(img_list, fn img ->\r\n      draw_movenet(img)\r\n      |> CImg.display_kino(:jpeg)\r\n    end)\r\n  end\r\n\r\n  def run(path) do\r\n    CImg.load(path)\r\n    |> draw_movenet()\r\n    |> CImg.display_kino(:jpeg)\r\n  end\r\n\r\n  defp draw_movenet(img) do\r\n    with {:ok, res} <- Movenet.apply(img) do\r\n      Enum.reduce(res, CImg.builder(img), fn {x1, y1, x2, y2, color}, canvas ->\r\n        CImg.draw_line(canvas, x1, y1, x2, y2, color, thick: 5)\r\n      end)\r\n    end\r\n  end\r\nend\r\n```","ref":"movenet.html#2-defining-execution-module-demomovenet","title":"2.Defining execution module DemoMovenet - Pose Estimation: MoveNet","type":"extras"},{"doc":"```elixir\r\nimg_list = LiveMovenet.img_list(\"young-people-dancing\", 1..200)\r\n```\r\n\r\n```elixir\r\nLiveMovenet.animate(img_list)\r\n```","ref":"movenet.html#3-let-s-try-it","title":"3.Let's try it - Pose Estimation: MoveNet","type":"extras"},{"doc":"&#9633;","ref":"movenet.html#4-til","title":"4.TIL ;-) - Pose Estimation: MoveNet","type":"extras"},{"doc":"# Object Detection: YOLOv4\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\n# System.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:cimg, \"~> 0.1.14\"},\r\n  {:postdnn, \"~> 0.1.5\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"yolov4.html","title":"Object Detection: YOLOv4","type":"extras"},{"doc":"Pytorch-YOLOv4\r\n\r\n* https://github.com/Tianxiaomo/pytorch-YOLOv4\r\n\r\nThis note usee the pretraind model converted from above project ;-)\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"yolov4.html#0-original-work","title":"0.Original work - Object Detection: YOLOv4","type":"extras"},{"doc":"","ref":"yolov4.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Object Detection: YOLOv4","type":"extras"},{"doc":"* Model\r\n\r\n  yolov4_1_3_608_608_static.tflite\r\n\r\n* Pre-processing\r\n\r\n  Resize the input image to the size {608,608}, normalize to {0.0,1.0} and transpose NCHW.\r\n\r\n* Post-processing\r\n\r\n  Filtering Boxes(output[0]) and Scores(output[1]) with Multi-class Non Maximum Suppression.\r\n\r\n```elixir\r\ndefmodule YOLOv4 do\r\n  @moduledoc \"\"\"\r\n  Original work:\r\n    Pytorch-YOLOv4 - https://github.com/Tianxiaomo/pytorch-YOLOv4\r\n  \"\"\"\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/yolov4_1_3_608_608_static.tflite\",\r\n    url:\r\n      \"https://drive.google.com/uc?authuser=0&export=download&confirm=t&id=1z02aAUJ_phk3mom_w7J1fKbe9F_UM1HT\",\r\n    inputs: [f32: {1, 3, 608, 608}],\r\n    outputs: [f32: {1, 22743, 1, 4}, f32: {1, 22743, 80}]\r\n\r\n  def apply(img) do\r\n    # preprocess\r\n    input0 =\r\n      img\r\n      |> CImg.resize({608, 608})\r\n      |> CImg.to_binary([{:range, {0.0, 1.0}}, :nchw])\r\n\r\n    # prediction\r\n    outputs =\r\n      session()\r\n      |> NNInterp.set_input_tensor(0, input0)\r\n      |> NNInterp.invoke()\r\n\r\n    # postprocess\r\n    boxes = NNInterp.get_output_tensor(outputs, 0)\r\n    scores = NNInterp.get_output_tensor(outputs, 1)\r\n\r\n    PostDNN.non_max_suppression_multi_class(\r\n      {22743, 80},\r\n      boxes,\r\n      scores,\r\n      boxrepr: :corner,\r\n      label: \"./model/coco.label\"\r\n    )\r\n  end\r\nend\r\n```\r\n\r\nLaunch `YOLOv4`.\r\n\r\n```elixir\r\n# OnnxInterp.stop(Resnet18)\r\nYOLOv4.start_link([])\r\n```\r\n\r\nDisplay the properties of the `YOLOv4` model.\r\n\r\n```elixir\r\nTflInterp.info(YOLOv4)\r\n```","ref":"yolov4.html#1-defining-the-inference-module-yolov4","title":"1.Defining the inference module: YOLOv4 - Object Detection: YOLOv4","type":"extras"},{"doc":"```elixir\r\ndefmodule LiveYOLOv4 do\r\n  @palette CImg.Util.rand_palette(\"./model/coco.label\")\r\n\r\n  def run(path) do\r\n    img = CImg.load(path)\r\n\r\n    with {:ok, res} <- YOLOv4.apply(img) do\r\n      IO.inspect(res)\r\n\r\n      Enum.reduce(res, CImg.builder(img), &draw_item(&1, &2))\r\n      |> CImg.display_kino(:jpeg)\r\n    end\r\n  end\r\n\r\n  defp draw_item({name, boxes}, canvas) do\r\n    color = @palette[name]\r\n\r\n    Enum.reduce(boxes, canvas, fn [_score, x1, y1, x2, y2, _index], canvas ->\r\n      [x1, y1, x2, y2] = PostDNN.clamp([x1, y1, x2, y2], {0.0, 1.0})\r\n\r\n      CImg.fill_rect(canvas, x1, y1, x2, y2, color, 0.35)\r\n    end)\r\n  end\r\nend\r\n```","ref":"yolov4.html#2-defining-execution-module-liveyolov4","title":"2.Defining execution module LiveYOLOv4 - Object Detection: YOLOv4","type":"extras"},{"doc":"```elixir\r\nLiveYOLOv4.run(\"dog.jpg\")\r\n```","ref":"yolov4.html#3-let-s-try-it","title":"3.Let's try it - Object Detection: YOLOv4","type":"extras"},{"doc":"&#9633;","ref":"yolov4.html#appendix","title":"Appendix - Object Detection: YOLOv4","type":"extras"},{"doc":"# Resnet18 image classification\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\n# System.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:cimg, \"~> 0.1.14\"},\r\n  {:nx, \"~> 0.4.0\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"resnet18.html","title":"Resnet18 image classification","type":"extras"},{"doc":"torchvision.models.resnet18 -  pre-trained model included in Pytorch.\r\n\r\n* https://pytorch.org/vision/main/models/generated/torchvision.models.resnet18.html\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"resnet18.html#0-original-work","title":"0.Original work - Resnet18 image classification","type":"extras"},{"doc":"","ref":"resnet18.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Resnet18 image classification","type":"extras"},{"doc":"* Model\r\n\r\n  resnet18.axon: get from \"https://github.com/shoz-f/tfl_interp/releases/download/0.0.1/resnet18.tflite\" if not existed.\r\n\r\n* Pre-processing\r\n\r\n  Resize the input image to the size `{@width, @height}` and gaussian normalize.\r\n\r\n* Post-processing\r\n\r\n  Sort outputs and take first item.\r\n\r\n```elixir\r\ndefmodule Resnet18 do\r\n  @width 224\r\n  @height 224\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/resnet18.tflite\",\r\n    url: \"https://github.com/shoz-f/tfl_interp/releases/download/0.0.1/resnet18.tflite\",\r\n    inputs: [f4: {1, 3, @height, @width}],\r\n    outputs: [f4: {1, 1000}]\r\n\r\n  @imagenet1000 (for item <- File.stream!(\"./imagenet1000.label\") do\r\n                   String.trim_trailing(item)\r\n                 end)\r\n                |> Enum.with_index(&{&2, &1})\r\n                |> Enum.into(%{})\r\n\r\n  def apply(img, top \\\\ 1) do\r\n    # preprocess\r\n    input0 =\r\n      CImg.builder(img)\r\n      |> CImg.resize({@width, @height})\r\n      |> CImg.to_binary([{:gauss, {{123.7, 58.4}, {116.3, 57.1}, {103.5, 57.4}}}, :nchw])\r\n\r\n    # prediction\r\n    output0 =\r\n      session()\r\n      |> NNInterp.set_input_tensor(0, input0)\r\n      |> NNInterp.invoke()\r\n      |> NNInterp.get_output_tensor(0)\r\n      |> Nx.from_binary(:f32)\r\n      |> Nx.reshape({1000})\r\n\r\n    # postprocess\r\n    # softmax\r\n    then(Nx.exp(output0), fn exp -> Nx.divide(exp, Nx.sum(exp)) end)\r\n    |> Nx.argsort(direction: :desc)\r\n    |> Nx.slice([0], [top])\r\n    |> Nx.to_flat_list()\r\n    |> Enum.map(&@imagenet1000[&1])\r\n  end\r\nend\r\n```\r\n\r\nLaunch `Resnet18`.\r\n\r\n```elixir\r\n# TflInterp.stop(Resnet18)\r\nResnet18.start_link([])\r\n```\r\n\r\nDisplay the properties of the `Resnet18` model.\r\n\r\n```elixir\r\nTflInterp.info(Resnet18)\r\n```","ref":"resnet18.html#1-defining-the-inference-module-resnet18","title":"1.Defining the inference module: ResNet18 - Resnet18 image classification","type":"extras"},{"doc":"Load a photo and apply Resnet18 to it.\r\n\r\n```elixir\r\nimg = CImg.load(\"lion.jpg\")\r\nKino.render(CImg.display_kino(img, :jpeg))\r\n\r\nResnet18.apply(img, 3)\r\n```\r\n\r\n&#9633;","ref":"resnet18.html#2-let-s-try-it","title":"2.Let's try it - Resnet18 image classification","type":"extras"},{"doc":"# Hair Segmentation\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\nSystem.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:cimg, \"~> 0.1.19\"},\r\n  {:nx, \"~> 0.4.0\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"hairsegmentation.html","title":"Hair Segmentation","type":"extras"},{"doc":"\"Real-time hair segmentation and recoloring on Mobile GPUs\", Google Research.\r\n* https://sites.google.com/view/perception-cv4arvr/hair-segmentation\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"hairsegmentation.html#0-original-work","title":"0.Original work - Hair Segmentation","type":"extras"},{"doc":"","ref":"hairsegmentation.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Hair Segmentation","type":"extras"},{"doc":"* Model\r\n\r\n  hair_segmentation.tflite: get from \"https://storage.googleapis.com/mediapipe-assets/hair_segmentation.tflite\" if not existed.\r\n\r\n* Pre-processing\r\n\r\n  Resize the input image to the size `{@width, @height}` and normalize {0.0, 1.0}.\r\n\r\n* Post-processing\r\n\r\n  Overlap the mask on the input image.\r\n\r\n```elixir\r\ndefmodule HairSegmentation do\r\n  @width 512\r\n  @height 512\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/hair_segmentation.tflite\",\r\n    url: \"https://storage.googleapis.com/mediapipe-assets/hair_segmentation.tflite\",\r\n    inputs: [f32: {1, @width, @height, 4}],\r\n    outputs: [f32: {1, @width, @height, 2}]\r\n\r\n  def apply(img) do\r\n    # preprocess\r\n    input0 =\r\n      CImg.builder(img)\r\n      |> CImg.resize({@width, @height})\r\n      |> CImg.append(CImg.create(@width, @height, 1, 1, 0), :c)\r\n      |> CImg.to_binary([{:range, {0.0, 1.0}}])\r\n\r\n    # prediction\r\n    output =\r\n      session()\r\n      |> NNInterp.set_input_tensor(0, input0)\r\n      |> NNInterp.invoke()\r\n      |> NNInterp.get_output_tensor(0)\r\n      |> Nx.from_binary(:f32)\r\n      |> Nx.reshape({@height, @width, :auto})\r\n\r\n    # postprocess\r\n    [background, hair] =\r\n      Enum.map(0..1, fn i ->\r\n        Nx.slice_along_axis(output, i, 1, axis: 2) |> Nx.squeeze()\r\n      end)\r\n\r\n    {w, h, _, _} = CImg.shape(img)\r\n\r\n    Nx.greater(hair, background)\r\n    |> Nx.to_binary()\r\n    |> CImg.from_binary(@width, @height, 1, 1, dtype: \"  CImg.resize({w, h})  # make image\r\n  end\r\n\r\n  def coloring(img, color, opacity \\\\ 0.5) do\r\n    mask = HairSegmentation.apply(img)\r\n    CImg.paint_mask(img, mask, color, opacity)\r\n  end\r\nend\r\n```\r\n\r\nLaunch `HairSegmentation`.\r\n\r\n```elixir\r\n# TflInterp.stop(HairSegmentation)\r\nHairSegmentation.start_link([])\r\n```\r\n\r\nDisplay the properties of the `HairSegmentation` model.\r\n\r\n```elixir\r\nTflInterp.info(HairSegmentation)\r\n```","ref":"hairsegmentation.html#1-defining-the-inference-module-hairsegmentation","title":"1.Defining the inference module: HairSegmentation - Hair Segmentation","type":"extras"},{"doc":"Load a photo and apply HairSegmentation to it.\r\n\r\n```elixir\r\nimg = CImg.load(\"photo_girl.jpg\")\r\ncolored = HairSegmentation.coloring(img, [{0, 255, 0}], 0.3)\r\n\r\nEnum.map([img, colored], &CImg.display_kino(&1, :jpeg))\r\n|> Kino.Layout.grid(columns: 2)\r\n```\r\n\r\n&#9633;","ref":"hairsegmentation.html#2-let-s-try-it","title":"2.Let's try it - Hair Segmentation","type":"extras"},{"doc":"# Fast Neural Style Transfer\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\nSystem.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:cimg, \"~> 0.1.20\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"candy.html","title":"Fast Neural Style Transfer","type":"extras"},{"doc":"Fast Neural Style Transfer\r\n\r\n* https://github.com/onnx/models/tree/main/vision/style_transfer/fast_neural_style\r\n\r\nfast-neural-style in PyTorch\r\n\r\n* https://github.com/pytorch/examples/tree/main/fast_neural_style\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"candy.html#0-original-work","title":"0.Original work - Fast Neural Style Transfer","type":"extras"},{"doc":"","ref":"candy.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Fast Neural Style Transfer","type":"extras"},{"doc":"* Model\r\n\r\n  candy.tflite: get from \"https://github.com/shoz-f/tinyML_livebook/releases/download/model/candy.tflite\" if not existed.\r\n\r\n* Pre-processing\r\n\r\n  Resize the input image to {@width, @height}, normalize it to a range of {0.0, 255.0} and transpose NCHW.\r\n\r\n* Post-processing\r\n\r\n  The candy colored image is outputted directly by this model.\r\n\r\n```elixir\r\ndefmodule Candy do\r\n  @width 224\r\n  @height 224\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/candy.tflite\",\r\n    url: \"https://github.com/shoz-f/tinyML_livebook/releases/download/model/candy.tflite\",\r\n    inputs: [f32: {1, @height, @width, 3}],\r\n    outputs: [f32: {1, @height, @width, 3}]\r\n\r\n  def apply(img) do\r\n    # preprocess\r\n    input0 =\r\n      CImg.builder(img)\r\n      |> CImg.resize({@width, @height})\r\n      |> CImg.to_binary([{:range, {0.0, 255.0}}, :nchw])\r\n\r\n    # prediction\r\n    output =\r\n      session()\r\n      |> NNInterp.set_input_tensor(0, input0)\r\n      |> NNInterp.invoke()\r\n      |> NNInterp.get_output_tensor(0)\r\n\r\n    # postprocess\r\n    output\r\n    |> CImg.from_binary(@width, @height, 1, 3, [{:range, {0.0, 255.0}}, :nchw])\r\n    |> CImg.resize(img)\r\n  end\r\nend\r\n```\r\n\r\nLaunch `Candy`.\r\n\r\n```elixir\r\n# TflInterp.stop(Candy)\r\nCandy.start_link([])\r\n```\r\n\r\nDisplay the properties of the `Candy` model.\r\n\r\n```elixir\r\nTflInterp.info(Candy)\r\n```","ref":"candy.html#1-defining-the-inference-module-candy","title":"1.Defining the inference module: Candy - Fast Neural Style Transfer","type":"extras"},{"doc":"Load a photo and apply Candy to it.\r\n\r\n```elixir\r\nimg = CImg.load(\"flog.jpg\")\r\n\r\nresult = Candy.apply(img)\r\n\r\nEnum.map([img, result], &CImg.display_kino(&1, :jpeg))\r\n|> Kino.Layout.grid(columns: 2)\r\n```\r\n\r\n&#9633;","ref":"candy.html#2-let-s-try-it","title":"2.Let's try it - Fast Neural Style Transfer","type":"extras"},{"doc":"# Monocular Depth Estimation: MiDaS v2.1\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\nSystem.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:cimg, \"~> 0.1.19\"},\r\n  {:nx, \"~> 0.4.0\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"midas.html","title":"Monocular Depth Estimation: MiDaS v2.1","type":"extras"},{"doc":"Intelligent Systems Lab Org:\r\n\r\n\"Towards Robust Monocular Depth Estimation: Mixing Datasets for Zero-shot Cross-dataset Transfer\"\r\n\r\n* https://arxiv.org/abs/1907.01341v3\r\n* https://github.com/isl-org/MiDaS\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"midas.html#0-original-work","title":"0.Original work - Monocular Depth Estimation: MiDaS v2.1","type":"extras"},{"doc":"","ref":"midas.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Monocular Depth Estimation: MiDaS v2.1","type":"extras"},{"doc":"* Model\r\n\r\n  midas.tflite: get from \"https://github.com/isl-org/MiDaS/releases/download/v2_1/model_opt.tflite\" if not existed.\r\n\r\n* Pre-processing\r\n\r\n  Resize input image to {@width, @height} and normalize it to a range of {-1.0, 1.0}.\r\n\r\n* Post-processing\r\n\r\n  The depth image {@width, @height, 1} is outputted directly by this model.\r\n\r\n```elixir\r\ndefmodule Midas do\r\n  @width 256\r\n  @height 256\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/model_opt.tflite\",\r\n    url: \"https://github.com/isl-org/MiDaS/releases/download/v2_1/model_opt.tflite\",\r\n    inputs: [f32: {1, @height, @width, 3}],\r\n    outputs: [f32: {1, @height, @width, 3}]\r\n\r\n  def apply(img) do\r\n    # preprocess\r\n    input0 =\r\n      CImg.builder(img)\r\n      |> CImg.resize({@width, @height})\r\n      |> CImg.to_binary(range: {-1.0, 1.0})\r\n\r\n    # prediction\r\n    output =\r\n      session()\r\n      |> NNInterp.set_input_tensor(0, input0)\r\n      |> NNInterp.invoke()\r\n      |> NNInterp.get_output_tensor(0)\r\n      |> Nx.from_binary(:f32)\r\n      |> Nx.reshape({@height, @width})\r\n\r\n    # postprocess\r\n    [min, max] =\r\n      [Nx.window_min(output, {@height, @width}), Nx.window_max(output, {@height, @width})]\r\n      |> Enum.map(&Nx.squeeze/1)\r\n      |> Enum.map(&Nx.to_number/1)\r\n\r\n    {w, h, _, _} = CImg.shape(img)\r\n\r\n    Nx.subtract(output, min)\r\n    |> Nx.divide(max - min)\r\n    |> Nx.to_binary()\r\n    |> CImg.from_binary(@width, @height, 1, 1)\r\n    |> CImg.resize({w, h})\r\n  end\r\nend\r\n```\r\n\r\nLaunch `Midas`.\r\n\r\n```elixir\r\n# TflInterp.stop(Midas)\r\nMidas.start_link([])\r\n```\r\n\r\nDisplay the properties of the `Midas` model.\r\n\r\n```elixir\r\nTflInterp.info(Midas)\r\n```","ref":"midas.html#1-defining-the-inference-module-midas","title":"1.Defining the inference module: Midas - Monocular Depth Estimation: MiDaS v2.1","type":"extras"},{"doc":"Load a photo and apply Midas to it.\r\n\r\n```elixir\r\nimg = CImg.load(\"sample.jpg\")\r\n\r\nresult =\r\n  Midas.apply(img)\r\n  |> CImg.color_mapping(:jet)\r\n\r\nEnum.map([img, result], &CImg.display_kino(&1, :jpeg))\r\n|> Kino.Layout.grid(columns: 2)\r\n```\r\n\r\n&#9633;","ref":"midas.html#2-let-s-try-it","title":"2.Let's try it - Monocular Depth Estimation: MiDaS v2.1","type":"extras"},{"doc":"# Object Detection: YoloX\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\nSystem.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:cimg, \"~> 0.1.19\"},\r\n  {:nx, \"~> 0.4.0\"},\r\n  {:postdnn, \"~> 0.1.5\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"yolox.html","title":"Object Detection: YoloX","type":"extras"},{"doc":"Zheng Ge, Zheng and Liu, Songtao and Wang, Feng and Li, Zeming and Sun, Jian\r\n\r\n\"YOLOX: Exceeding YOLO Series in 2021\"\r\n\r\n* https://arxiv.org/abs/2107.08430\r\n* https://github.com/Megvii-BaseDetection/YOLOX\r\n\r\n> A technical article on YOLOX in Japanese\r\n> @koshian2 \"実装から見るYOLOX：2021年のYOLOシリーズを超えて\"\r\n> \r\n> * https://qiita.com/koshian2/items/af032cb102f48e789e66\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"yolox.html#0-original-work","title":"0.Original work - Object Detection: YoloX","type":"extras"},{"doc":"","ref":"yolox.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Object Detection: YoloX","type":"extras"},{"doc":"* Model\r\n\r\n  yolox.tflite: get from \"https://github.com/shoz-f/tinyML_livebook/releases/download/model/yolox_s.tflite\" if not existed.\r\n\r\n* Pre-processing\r\n\r\n  Resize input image to {@width, @height}, normalize it to a range of {0.0, 255.0} and transpose NCHW.\r\n\r\n* Post-processing\r\n\r\n  Divide the output to `boxes` and `scores`, and then filter them with Multi-class Non Maximum Suppression.\r\n\r\n```elixir\r\ndefmodule YoloX do\r\n  @width 640\r\n  @height 640\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/yolox_s.tflite\",\r\n    label: \"./model/coco.label\",\r\n    url: \"https://github.com/shoz-f/tinyML_livebook/releases/download/model/yolox_s.tflite\",\r\n    inputs: [f32: {1, 3, @height, @width}],\r\n    outputs: [f32: {1, 8400, 85}]\r\n\r\n  def apply(img) do\r\n    # preprocess\r\n    input0 =\r\n      CImg.builder(img)\r\n      |> CImg.resize({@width, @height})\r\n      |> CImg.to_binary([{:range, {0.0, 255.0}}, :nchw])\r\n\r\n    # prediction\r\n    output =\r\n      session()\r\n      |> NNInterp.set_input_tensor(0, input0)\r\n      |> NNInterp.invoke()\r\n      |> NNInterp.get_output_tensor(0)\r\n      |> Nx.from_binary(:f32)\r\n      |> Nx.reshape({:auto, 85})\r\n\r\n    # postprocess\r\n    output = Nx.transpose(output)\r\n\r\n    boxes = extract_boxes(output)\r\n    scores = extract_scores(output)\r\n\r\n    TflInterp.non_max_suppression_multi_class(\r\n      __MODULE__,\r\n      Nx.shape(scores),\r\n      Nx.to_binary(boxes),\r\n      Nx.to_binary(scores)\r\n    )\r\n  end\r\n\r\n  @grid PostDNN.meshgrid({@width, @height}, [8, 16, 32], [:transpose, :normalize])\r\n\r\n  defp extract_boxes(t) do\r\n    # decode box center coordinate on {1.0, 1.0}\r\n    center =\r\n      t[0..1]\r\n      # * pitch(x,y)\r\n      |> Nx.multiply(@grid[2..3])\r\n      # + grid(x,y)\r\n      |> Nx.add(@grid[0..1])\r\n\r\n    # decode box size\r\n    size =\r\n      t[2..3]\r\n      |> Nx.exp()\r\n      # * pitch(x,y)\r\n      |> Nx.multiply(@grid[2..3])\r\n\r\n    Nx.concatenate([center, size]) |> Nx.transpose()\r\n  end\r\n\r\n  defp extract_scores(t) do\r\n    Nx.multiply(t[4], t[5..-1//1])\r\n    |> Nx.transpose()\r\n  end\r\nend\r\n```\r\n\r\nLaunch `YoloX`.\r\n\r\n```elixir\r\n# TflInterp.stop(YoloX)\r\nYoloX.start_link([])\r\n```\r\n\r\nDisplay the properties of the `YoloX` model.\r\n\r\n```elixir\r\nTflInterp.info(YoloX)\r\n```","ref":"yolox.html#1-defining-the-inference-module-yolox","title":"1.Defining the inference module: YoloX - Object Detection: YoloX","type":"extras"},{"doc":"```elixir\r\ndefmodule DemoYoloX do\r\n  @palette CImg.Util.rand_palette(\"./model/coco.label\")\r\n\r\n  def run(path) do\r\n    img = CImg.load(path)\r\n\r\n    with {:ok, res} <- YoloX.apply(img) do\r\n      IO.inspect(res)\r\n\r\n      Enum.reduce(res, CImg.builder(img), &draw_item(&1, &2))\r\n      |> CImg.display_kino(:jpeg)\r\n    end\r\n  end\r\n\r\n  defp draw_item({name, boxes}, canvas) do\r\n    color = @palette[name]\r\n\r\n    Enum.reduce(boxes, canvas, fn [_score, x1, y1, x2, y2, _index], canvas ->\r\n      [x1, y1, x2, y2] = PostDNN.clamp([x1, y1, x2, y2], {0.0, 1.0})\r\n\r\n      CImg.fill_rect(canvas, x1, y1, x2, y2, color, 0.35)\r\n    end)\r\n  end\r\nend\r\n```","ref":"yolox.html#2-defining-execution-module-demoyolox","title":"2.Defining execution module DemoYoloX - Object Detection: YoloX","type":"extras"},{"doc":"Load a photo and apply YoloX to it.\r\n\r\n```elixir\r\nDemoYoloX.run(\"dog.jpg\")\r\n```\r\n\r\n&#9633;","ref":"yolox.html#3-let-s-try-it","title":"3.Let's try it - Object Detection: YoloX","type":"extras"},{"doc":"# Generative Inpainting\r\n\r\n```elixir\r\nFile.cd!(__DIR__)\r\n# for windows JP\r\nSystem.shell(\"chcp 65001\")\r\nSystem.put_env(\"NNCOMPILED\", \"YES\")\r\n\r\nMix.install([\r\n  {:tfl_interp, path: \"..\"},\r\n  {:cimg, \"~> 0.1.19\"},\r\n  {:kino, \"~> 0.7.0\"}\r\n])\r\n```","ref":"deepfillv2.html","title":"Generative Inpainting","type":"extras"},{"doc":"\"Generative Image Inpainting with Contextual Attention\"\r\n\r\n* https://arxiv.org/abs/1801.07892\r\n\r\n\"Free-Form Image Inpainting with Gated Convolution\"\r\n\r\n* https://arxiv.org/abs/1806.03589\r\n\r\nGitHub: Generative Image Inpainting\r\n\r\n* https://github.com/JiahuiYu/generative_inpainting\r\n\r\nThe tflite model `deepfillv2.tflite` is converted from their pretraind model.\r\n\r\n***Thanks a lot!!!***\r\n\r\n---","ref":"deepfillv2.html#0-original-work","title":"0.Original work - Generative Inpainting","type":"extras"},{"doc":"","ref":"deepfillv2.html#implementation-with-tflinterp-in-elixir","title":"Implementation with TflInterp in Elixir - Generative Inpainting","type":"extras"},{"doc":"* Model\r\n\r\n  deepfillv2.tflite: get from \"https://github.com/shoz-f/tfl_interp/releases/download/0.0.1/deepfillv2.tflite\" if not existed.\r\n\r\n* Pre-processing\r\n\r\n  Combine the original and mask images into a single image, then resize it to {@width, @height} and normalize it to a range of {0.0, 255.0} for further manipulation.\r\n\r\n* Post-processing\r\n\r\n  The inpainted image is outputted directly by this model.\r\n\r\n```elixir\r\ndefmodule DeepFillV2 do\r\n  @width 680\r\n  @height 512\r\n\r\n  alias TflInterp, as: NNInterp\r\n\r\n  use NNInterp,\r\n    model: \"./model/deepfillv2.tflite\",\r\n    url: \"https://github.com/shoz-f/tfl_interp/releases/download/0.0.1/deepfillv2.tflite\",\r\n    inputs: [f32: {1, @height, 2 * @width, 3}],\r\n    outputs: [u8: {1, @height, @width, 3}]\r\n\r\n  def apply(img, mask) do\r\n    # preprocess\r\n    input0 =\r\n      CImg.builder(img)\r\n      |> CImg.append(mask, :x)\r\n      |> CImg.resize({2 * @width, @height})\r\n      |> CImg.to_binary(range: {0.0, 255.0})\r\n\r\n    # prediction\r\n    {w, h, _, _} = CImg.shape(img)\r\n\r\n    session()\r\n    |> NNInterp.set_input_tensor(0, input0)\r\n    |> NNInterp.invoke()\r\n    |> NNInterp.get_output_tensor(0)\r\n    |> CImg.from_binary(@width, @height, 1, 3, [{:dtype, \"  CImg.resize({w, h})\r\n  end\r\nend\r\n```\r\n\r\nLaunch `DeepFillV2`.\r\n\r\n```elixir\r\n# TflInterp.stop(DeepFillV2)\r\nDeepFillV2.start_link([])\r\n```\r\n\r\nDisplay the properties of the `DeepFillV2` model.\r\n\r\n```elixir\r\nTflInterp.info(DeepFillV2)\r\n```","ref":"deepfillv2.html#1-defining-the-inference-module-deepfillv2","title":"1.Defining the inference module: DeepFillV2 - Generative Inpainting","type":"extras"},{"doc":"Load a photo and apply DeepFillV2 to it.\r\n\r\n```elixir\r\norigin = CImg.load(\"sample_raw.jpg\")\r\nmask = CImg.load(\"sample_mask.jpg\")\r\n\r\nresult = DeepFillV2.apply(origin, mask)\r\n\r\nEnum.map([origin, mask, result], &CImg.display_kino(&1, :jpeg))\r\n|> Kino.Layout.grid(columns: 2)\r\n```\r\n\r\n&#9633;","ref":"deepfillv2.html#2-let-s-try-it","title":"2.Let's try it - Generative Inpainting","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}